Newer
Older
#!/bin/bash
#
# TODO:
#
# * In case of an installed Dune, it should not be necessary to pass the
# dune-common dir to autogen.sh.
# * Check module names entered as dependencies.
set -e
Christian Engwer
committed
canonicalname(){
if test $# -ne 1; then
echo Usage: canonicalname path >&2
return 1
fi
file="`eval echo $1`" # expand ~
if test ! -e "$file"; then
echo $file: file not found >&2
return 1
fi
# if this is a symlink, then follow the symlink
if test -L "$file"; then
fdir="`dirname \"$file\"`"
flink="`readlink \"$file\"`"
if test -e "$flink"; then
# these are absolute links, or links in the CWD
canonicalname "$flink"
else
canonicalname "$fdir/$flink"
fi
else
# if this is a file, then remember the filename and
# canonicalize the directory name
if test -f "$file"; then
fdir="`dirname \"$file\"`"
fname="`basename \"$file\"`"
fdir="`canonicalname \"$fdir\"`"
echo "$fdir/$fname"
fi
# if this is a directory, then create an absolute
# directory name and we are done
if test -d "$file"; then
(cd "$file"; pwd)
fi
fi
Christian Engwer
committed
}
canonicalpath(){
if test $# -ne 1; then
echo Usage: canonicalpath path >&2
Christian Engwer
committed
return 1
fi
dirname "$(canonicalname "$1")"
pkg_config_dependencies(){
if test $# -ne 1; then
echo Usage: pkg_config_dependencies name >&2
return 1
fi
name="$1"
depends="`pkg-config --variable=DEPENDENCIES $name| sed -e 's/,/ /g'`"
for pkg in $depends; do
depends="$depends `pkg_config_dependencies $pkg`"
done
echo $depends
}
modulesexist(){
allfound=0
for dep in $1; do
found=0
for module in $2; do
if [ "$dep" = "$module" ]; then
found=1
break
fi
done
if [ "$found" = "0" ]; then
# Module not found in list, try pkg-config
pkg-config $module &> /dev/null
found=$?
fi
echo "ERROR:">&2
echo "Module with name $dep was not found" >&2
echo "Did you forget to specify it's location" >&2
echo "in the DUNE_CONTROL_PATH variable?">&2
echo >&2
98
99
100
101
102
103
104
105
106
107
108
109
110
111
112
113
114
115
116
117
118
119
120
121
122
123
124
125
126
127
128
129
130
131
132
133
134
135
136
make_unique(){
if [ "$#" = "1" ]; then
# take first word
for exclude_word in $1; do
break;
done
make_unique $exclude_word "$1" 0
else
local exclude_word="$1"
local words="$2"
local pos="$3"
local length=0
local i=0
local new_words=""
local cur=0
for word in $words; do
if [ $i -le $pos ]; then
i=$((i+1))
length=$((length+1))
new_words="$new_words $word"
continue
fi
if [ "$word" != "$exclude_word" ]; then
new_words="$new_words $word"
if [ "$((length-1))" = "$pos" ]; then
next_word="$word"
fi
length=$((length+1))
fi
done
if [ "$pos" -lt "$length" ]; then
# process next word
make_unique "$next_word" "$new_words" $((pos+1))
else
export UNIQUE_WORDS="$new_words"
fi
fi
}
echo
echo == Dune project/module generator ==
echo
echo duneproject will assist you in the creation of a new Dune application.
echo During this process a new directory with the name of your project will be
echo created. This directory will hold all configuration and Makefiles and a
echo simple example application.
echo
Sreejith Pulloor Kuttanikkad
committed
################## FIND AVAILABLE MODULES ##################
Sreejith Pulloor Kuttanikkad
committed
. "$(canonicalpath $0)/../lib/dunemodules.lib"
export PREFIX_DIR="`canonicalpath "$0"`/.."
extract_multiarch_pkg_config_path
# search for modules, both installed and src modules
find_modules_in_path
# sort modules to remove duplicates
sort_modules $FOUND_MODULES
FOUND_MODULES=$MODULES
if [ "$MODULES" = "" ]; then
echo "ERROR:">&2
echo " No dune modules were found!">&2
echo " Did you forget to specify the places where ">&2
echo " you installed your modules in the ">&2
echo " DUNE_CONTROL_PATH environment variable">&2
echo " and adjusted the PKG_CONFIG_PATH environment">&2
echo " accordingly?" >&2
################## READ CMDLINE OPTIONS ##########
PROJECT="$1"
DEPENDENCIES="$2"
VERSION="$3"
MAINTAINER="$4"
################## READ OPTIONS ##################
while [ "$DATACORRECT" != "y" -a "$DATACORRECT" != "Y" ]; do
while [ -z $PROJECT ]; do
read -p "1) Name of your new Project? (e.g.: dune-grid): " PROJECT
if echo "$MODULES" | grep -q ^$PROJECT$; then
read -p " A module named $PROJECT already exists. Continue anyway? [y/N] " CONT
if test x$DELETE = xy -o x$DELETE = xY; then
PROJECT=""
fi
fi
Markus Blatt
committed
MODULE="$PROJECT"
echo "2) Which modules should this module depend on?"
echo " Following modules are found:"
echo " $MODULES"
# for i in $MODULES; do echo -n " $i"; done
# echo ""
while [ -z "$DEPENDENCIES" ]; do
read -p " Enter space separated list: " DEPENDENCIES
Markus Blatt
committed
done
modulesexist "$DEPENDENCIES" "$MODULES"
if [ "$DEPOK" != 0 ]; then
DEPENDENCIES=""
fi
while [ -z $VERSION ]; do
read -p "3) Project/Module version? " VERSION
done
while [ -z "$MAINTAINER" ]; do
read -p "4) Maintainer's email address? " MAINTAINER
done
echo
echo "creating Project \"$PROJECT\", version $VERSION "
Markus Blatt
committed
echo "which depends on \"$DEPENDENCIES\""
echo "with maintainer \"$MAINTAINER\""
read -p "Are these informations correct? [y/N] " DATACORRECT
# reset data if necessary
if [ "$DATACORRECT" != "y" -a "$DATACORRECT" != "Y" ]; then
PROJECT=""
DEPENDENCIES=""
VERSION=""
MAINTAINER=""
fi
done
echo
echo "A sample code $MODULE.cc is generated in the \"$PROJECT\" directory."
echo "Look at the README and dune.module files there."
echo "Now you can run the dunecontrol script which will setup the new module."
echo "Sometimes you may have to tweak configure.ac a bit."
Sreejith Pulloor Kuttanikkad
committed
if test -d $PROJECT; then
echo WARNING:
echo "A directory with the name $PROJECT already exists."
echo "Do you want to continue anyway?"
read -p "Type Y to overwrite the old directory, N to abort. [y/N] " DELETE
if test x$DELETE != xy -a x$DELETE != xY; then
echo Abort...
exit 1
fi
rm -rf "$PROJECT"
fi
mkdir "$PROJECT"
Sreejith Pulloor Kuttanikkad
committed
################## dune.module ##################
cat > "$PROJECT/dune.module" <<C_DELIM
################################
# Dune module information file #
################################
Sreejith Pulloor Kuttanikkad
committed
#Name of the module
Module: $MODULE
Version: $VERSION
Maintainer: $MAINTAINER
Sreejith Pulloor Kuttanikkad
committed
#depending on
Depends: $DEPENDENCIES
Sreejith Pulloor Kuttanikkad
committed
C_DELIM
################## CONFIGURE.AC ##################
## Create the parameters passed to DUNE_CHECK_ALL
# save module list of dunemodules.inc
save_MODULES=$MODULES
for name in $DEPENDENCIES; do
mod="`fix_variable_name $name`"
if test "x$(eval echo \$HAVE_$mod)" != "x"; then
# found via dunemodules.inc
sort_modules "$mod"
for mod in $MODULES; do
M_DEPS="$M_DEPS $(eval echo \$NAME_$mod)"
done
MODULES=$save_MODULES
else
# found via pkg-config
M_DEPS="`pkg_config_dependencies $name` $name"
fi
for dep in $M_DEPS; do
# insert , between modules
j=0
for dep in $UNIQUE_WORDS; do
if [ "$j" = "0" ]; then
CHECK="$dep"
j=1
else
CHECK="$CHECK, $dep"
fi
done
echo "------------------------------------------"
echo "writing initial files:"
# we need the module with _ instead of - to not confuse automake
fix_and_assign CMODULE $MODULE
NAME=`echo $PROJECT | sed -e 's/dune[_-]//' | tr '-' '_'`
UNAME=`echo $PROJECT | tr '-' '_' | sed 's/\(.*\)/\U\1/'`
################## CONFIGURE.AC ##################
cat > "$PROJECT/configure.ac" <<C_DELIM
# Process this file with autoconf to produce a configure script.
AC_PREREQ([2.62])
DUNE_AC_INIT # gets module version from dune.module file
AC_CONFIG_SRCDIR([src/$CMODULE.cc])
AC_CONFIG_HEADERS([config.h])
Sreejith Pulloor Kuttanikkad
committed
# this module depends on $DEPENDENCIES
# this implies checking for $CHECK
# implicitly set the Dune-flags everywhere
AC_SUBST(AM_CPPFLAGS, \$DUNE_CPPFLAGS)
AC_SUBST(AM_LDFLAGS, \$DUNE_LDFLAGS)
LIBS="\$DUNE_LIBS"
src/Makefile
cmake/modules/Makefile
doc/Makefile
doc/doxygen/Doxyfile
dune/Makefile
dune/$NAME/Makefile
AC_OUTPUT
# finally print the summary information
DUNE_SUMMARY_ALL
C_DELIM
################## README ##################
cat > "$PROJECT/README" <<R_DELIM
Preparing the Sources
=========================
Additional to the software mentioned in README you'll need the
following programs installed on your system:
automake >= 1.9
autoconf >= 2.62
libtool
Getting started
---------------
If these preliminaries are met, you should run
dunecontrol all
which will find all installed dune modules as well as all dune modules
(not installed) which sources reside in a subdirectory of the current
directory. Note that if dune is not installed properly you will either
have to add the directory where the dunecontrol script resides (probably
./dune-common/bin) to your path or specify the relative path of the script.
On your project and all uninstalled DUNE source modules found the script
will then calls the GNU autoconf/automake to create a ./configure-script
and the Makefiles. Afterwards that configure script will be called and the
modules will be build using make all
Most probably you'll have to provide additional information to dunecontrol
(e. g. compilers, configure options) and/or make options.
The most convenient way is to use options files in this case. The files
defining three variables:
AUTOGEN_FLAGS flags passed to autogen
CONFIGURE_FLAGS flags passed to configure
MAKE_FLAGS flags passed to make
An example options file might look like this:
#use this options to autogen, configure and make if no other options are given
AUTOGEN_FLAGS="--ac=2.50 --ac=1.8" #Forces automake 2,50 and autoconf 1.8
CONFIGURE_FLAGS="CXX=g++-3.4 --prefix=/install/path" #force g++-3.4 as compiler
MAKE_FLAGS=install #Per default run make install instead of simply make
If you save this information into example.opts you can path the opts file to
dunecontrol via the --opts option, e. g.
dunecontrol --opts=example.opts all
To get a full list of available configure flags just run
dunecontrol configure --help
after running at least
dunecontrol autogen
More info
---------
See
dunecontrol --help
for further options.
The full build-system is described in the dune-common/doc/buildsystem (SVN version) or under share/doc/dune-common/buildsystem if you installed DUNE!
\$Id$
R_DELIM
################## MAKEFILE.AM ##################
DISTCHECK_CONFIGURE_FLAGS=
for name in $DEPENDENCIES; do
capital=`echo $name | tr '[a-z-]' '[A-Z_]'`
DISTCHECK_CONFIGURE_FLAGS=$DISTCHECK_CONFIGURE_FLAGS"--with-${name}=\$(${capital}_ROOT) "
done
cat> "$PROJECT/Makefile.am" << M_DELIM
# \$Id$
# we need the module file to be able to build via dunecontrol
EXTRA_DIST = dune.module \\
CMakeLists.txt \\
config.h.cmake
if BUILD_DOCS
# TODO: set up documentation tree automatically
#SUBDIRS += doc
endif
Sreejith Pulloor Kuttanikkad
committed
# don't follow the full GNU-standard
# we need automake 1.9 or newer
AUTOMAKE_OPTIONS = foreign 1.9
Sreejith Pulloor Kuttanikkad
committed
# pass most important options when "make distcheck" is used
DISTCHECK_CONFIGURE_FLAGS = $DISTCHECK_CONFIGURE_FLAGS CXX="\$(CXX)" CC="\$(CC)"
include \$(top_srcdir)/am/top-rules
include \$(top_srcdir)/am/global-rules
Markus Blatt
committed
# Generate package configuration files for finding
# installed modules with CMake
include \$(top_srcdir)/am/cmake-pkg-config
Markus Blatt
committed
################## CMakeLists.txt ##################
echo "- $PROJECT/CMakeLists.txt"
cat> "$PROJECT/CMakeLists.txt" << M_DELIM
Markus Blatt
committed
cmake_minimum_required(VERSION 2.8.6)
project($PROJECT CXX)
if(NOT (dune-common_DIR OR dune-common_ROOT OR
"\${CMAKE_PREFIX_PATH}" MATCHES ".*dune-common.*"))
string(REPLACE \${CMAKE_PROJECT_NAME} dune-common dune-common_DIR
\${PROJECT_BINARY_DIR})
endif()
#find dune-common and set the module path
find_package(dune-common REQUIRED)
list(APPEND CMAKE_MODULE_PATH "\${PROJECT_SOURCE_DIR}/cmake/modules"
\${dune-common_MODULE_PATH})
#include the dune macros
include(DuneMacros)
# start a dune project with information from dune.module
dune_project()
add_subdirectory("src")
add_subdirectory("m4")
add_subdirectory("dune")
add_subdirectory("doc")
add_subdirectory("cmake/modules")
# finalize the dune project, e.g. generating config.h etc.
finalize_dune_project(GENERATE_CONFIG_H_CMAKE)
echo 'A stamp file to signify that this directory comes from a version control system, not an unpacked tarball' > $PROJECT/stamp-vc
################## PROJECT.PC.IN ##################
echo "- $PROJECT/$MODULE.pc.in"
cat> "$PROJECT/$MODULE.pc.in" << CC_DELIM
prefix=@prefix@
exec_prefix=@exec_prefix@
libdir=@libdir@
includedir=@includedir@
CXX=@CXX@
CC=@CC@
DEPENDENCIES=@REQUIRES@
Name: @PACKAGE_NAME@
Version: @VERSION@
Description: $MODULE module
URL: http://dune-project.org/
Requires: ${DEPENDENCIES}
Libs: -L${libdir}
Cflags: -I${includedir}
CC_DELIM
echo " Please remember to update your $PROJECT/$MODULE.pc.in,"
echo " Description and URL are missing right now."
533
534
535
536
537
538
539
540
541
542
543
544
545
546
547
548
549
550
551
552
553
554
555
556
557
558
559
560
561
562
563
564
565
566
567
568
569
570
571
572
573
574
575
576
577
578
579
580
581
582
583
584
################# config.h.cmake #####################
echo "- $PROJECT/config.h.cmake"
cat> "$PROJECT/config.h.cmake" <<EOF
/* begin $NAME
put the definitions for config.h specific to
your project here. Everything above will be
overwritten
*/
/* begin private */
/* Name of package */
#define PACKAGE "@DUNE_MOD_NAME"
/* Define to the address where bug reports for this package should be sent. */
#define PACKAGE_BUGREPORT "@DUNE_MAINTAINER@"
/* Define to the full name of this package. */
#define PACKAGE_NAME "@DUNE_MOD_NAME@"
/* Define to the full name and version of this package. */
#define PACKAGE_STRING "@DUNE_MOD_NAME@ @DUNE_MOD_VERSION@"
/* Define to the one symbol short name of this package. */
#define PACKAGE_TARNAME "@DUNE_MOD_NAME@"
/* Define to the home page for this package. */
#define PACKAGE_URL "@DUNE_MOD_URL@"
/* Define to the version of this package. */
#define PACKAGE_VERSION "@DUNE_MOD_VERSION@"
/* end private */
/* Define to the version of $PROJECT */
#define ${UNAME}_VERSION "@${UNAME}_VERSION@"
/* Define to the major version of $PROJECT */
#define ${UNAME}_VERSION_MAJOR @${UNAME}_VERSION_MAJOR@
/* Define to the minor version of $PROJECT */
#define ${UNAME}_VERSION_MINOR @${UNAME}_VERSION_MINOR@
/* Define to the revision of $PROJECT */
#define ${UNAME}_VERSION_REVISION @${UNAME}_VERSION_REVISION@
/* end $NAME
Everything below here will be overwritten
*/
EOF
## done
###############################################################
################## The source subdirectory ####################
###############################################################
mkdir "$PROJECT/src"
################## src/CMakeLists.txt ##################
echo "- $PROJECT/src/CMakeLists.txt"
cat> "$PROJECT/src/CMakeLists.txt" << M_DELIM
add_executable("${CMODULE}" ${CMODULE}.cc)
target_link_dune_default_libraries("${CMODULE}")
M_DELIM
################## src/MAKEFILE.AM ##################
echo "- $PROJECT/src/Makefile.am"
cat> "$PROJECT/src/Makefile.am" << M_DELIM
SUBDIRS =
noinst_PROGRAMS = ${CMODULE}
${CMODULE}_SOURCES = $CMODULE.cc
${CMODULE}_CPPFLAGS = \$(AM_CPPFLAGS) \\
\$(DUNEMPICPPFLAGS) \\
\$(UG_CPPFLAGS) \\
\$(AMIRAMESH_CPPFLAGS) \\
\$(ALBERTA_CPPFLAGS) \\
\$(ALUGRID_CPPFLAGS)
# The libraries have to be given in reverse order (most basic libraries
# last). Also, due to some misunderstanding, a lot of libraries include the
# -L option in LDFLAGS instead of LIBS -- so we have to include the LDFLAGS
# here as well.
${CMODULE}_LDADD = \\
\$(DUNE_LDFLAGS) \$(DUNE_LIBS) \\
\$(ALUGRID_LDFLAGS) \$(ALUGRID_LIBS) \\
\$(ALBERTA_LDFLAGS) \$(ALBERTA_LIBS) \\
\$(AMIRAMESH_LDFLAGS) \$(AMIRAMESH_LIBS) \\
\$(UG_LDFLAGS) \$(UG_LIBS) \\
\$(DUNEMPILIBS) \\
\$(LDADD)
${CMODULE}_LDFLAGS = \$(AM_LDFLAGS) \\
\$(DUNEMPILDFLAGS) \\
\$(UG_LDFLAGS) \\
\$(AMIRAMESH_LDFLAGS) \\
\$(ALBERTA_LDFLAGS) \\
\$(ALUGRID_LDFLAGS) \\
\$(DUNE_LDFLAGS)
# don't follow the full GNU-standard
# we need automake 1.9
AUTOMAKE_OPTIONS = foreign 1.9
# pass most important options when "make distcheck" is used
DISTCHECK_CONFIGURE_FLAGS = $DISTCHECK_CONFIGURE_FLAGS CXX="\$(CXX)" CC="\$(CC)"
include \$(top_srcdir)/am/global-rules
M_DELIM
################## PROJECT.CC ##################
echo "- $PROJECT/src/$CMODULE.cc"
cat> "$PROJECT/src/$CMODULE.cc" << CC_DELIM
Sreejith Pulloor Kuttanikkad
committed
#ifdef HAVE_CONFIG_H
# include "config.h"
#endif
#include <iostream>
#include <dune/common/parallel/mpihelper.hh> // An initializer of MPI
#include <dune/common/exceptions.hh> // We use exceptions
int main(int argc, char** argv)
{
try{
//Maybe initialize Mpi
Dune::MPIHelper& helper = Dune::MPIHelper::instance(argc, argv);
std::cout << "Hello World! This is ${PROJECT}." << std::endl;
if(Dune::MPIHelper::isFake)
std::cout<< "This is a sequential program." << std::endl;
else
std::cout<<"I am rank "<<helper.rank()<<" of "<<helper.size()
<<" processes!"<<std::endl;
return 0;
}
catch (Dune::Exception &e){
std::cerr << "Dune reported error: " << e << std::endl;
}
catch (...){
std::cerr << "Unknown exception thrown!" << std::endl;
}
}
CC_DELIM
################## M4/MAKEFILE ####################
mkdir "$PROJECT/m4"
echo "- $PROJECT/m4/Makefile.am"
cat> "$PROJECT/m4/Makefile.am" << CC_DELIM
aclocaldir = \$(datadir)/dune/aclocal
EXTRA_DIST = \$(M4FILES) CMakeLists.txt
echo "- $PROJECT/m4/CMakeLists.txt"
cat> "$PROJECT/m4/CMakeLists.txt" << CC_DELIM
install(PROGRAMS $MODULE.m4 DESTINATION \${CMAKE_INSTALL_DATAROOTDIR}/dune/aclocal)
CC_DELIM
################## M4/PROJECT.M4 ####################
M4_MODULE=`echo $MODULE | tr '[a-z-]' '[A-Z_]'`
echo "- $PROJECT/m4/$MODULE.m4"
cat> "$PROJECT/m4/$MODULE.m4" << CC_DELIM
dnl -*- autoconf -*-
# Macros needed to find $MODULE and dependent libraries. They are called by
# the macros in \${top_src_dir}/dependencies.m4, which is generated by
# "dunecontrol autogen"
# Additional checks needed to build $MODULE
# This macro should be invoked by every module which depends on $MODULE, as
# well as by $MODULE itself
# Additional checks needed to find $MODULE
# This macro should be invoked by every module which depends on $MODULE, but
# not by $MODULE itself
AC_DEFUN([${M4_MODULE}_CHECK_MODULE],
[
DUNE_CHECK_MODULES([$MODULE],[$NAME/$NAME.hh])
])
################################################################
################## The headers subdirectory ####################
################################################################
echo "- $PROJECT/dune/$NAME"
mkdir "$PROJECT/dune"
mkdir "$PROJECT/dune/$NAME"
################## dune/Makefile.am ####################
echo "- $PROJECT/dune/Makefile.am"
cat> $PROJECT/dune/Makefile.am <<EOF
SUBDIRS = $NAME
include \$(top_srcdir)/am/global-rules
EOF
echo "- $PROJECT/dune/CMakeLists.txt"
cat> $PROJECT/dune/CMakeLists.txt <<EOF
add_subdirectory($NAME)
EOF
################## dune/$NAME/Makefile.am ##############
echo "- $PROJECT/dune/$NAME/Makefile.am"
cat> $PROJECT/dune/$NAME/Makefile.am <<EOF
${NAME}includedir = \$(includedir)/dune/${NAME}
${NAME}include_HEADERS = ${NAME}.hh
include \$(top_srcdir)/am/global-rules
EOF
echo "- $PROJECT/dune/$NAME/CMakeLists.txt"
cat> $PROJECT/dune/$NAME/CMakeLists.txt <<EOF
#install headers
install(FILES ${NAME}.hh DESTINATION include/dune/$NAME)
EOF
################## dune/$NAME/$NAME.hh #################
echo "- $PROJECT/dune/$NAME/$NAME.hh"
cat> $PROJECT/dune/$NAME/$NAME.hh <<EOF
#ifndef DUNE_$NAME.hh
#define DUNE_$NAME.hh
// add your classes here
#endif // DUNE_$NAME.hh
EOF
###############################################################
################## The doc subdirectory ####################
###############################################################
mkdir "$PROJECT/doc"
################## doc/Makefile.am ####################
echo "- $PROJECT/doc/Makefile.am"
cat> "$PROJECT/doc/Makefile.am" << CC_DELIM
CURDIR = doc
BASEDIR = ..
# add list of html files to generate from wml
PAGES=
docdir=\$(datadir)/doc/${PROJECT}
include \$(top_srcdir)/am/webstuff
include \$(top_srcdir)/am/global-rules
CC_DELIM
echo "- $PROJECT/doc/CMakeLists.txt"
cat> "$PROJECT/doc/CMakeLists.txt" << CC_DELIM
add_subdirectory("doxygen")
CC_DELIM
###############################################################
############### The doc/doxygen subdirectory ##################
###############################################################
mkdir "$PROJECT/doc/doxygen"
#################### basic Doxylocal ##########################
echo "- $PROJECT/doc/doxygen/Doxylocal"
if [ "x`which doxygen`" == "x" ]; then
echo "Doxygen is not installed! Your documentation will not work without."
fi
827
828
829
830
831
832
833
834
835
836
837
838
839
840
841
842
843
844
845
846
847
848
849
850
851
852
853
854
855
856
857
858
859
860
# Where to search and which files to use
cat> $PROJECT/doc/doxygen/Doxylocal << CC_DELIM
# This file contains local changes to the doxygen configuration
# please us '+=' to add file/directories to the lists
# The INPUT tag can be used to specify the files and/or directories that contain
# documented source files. You may enter file names like "myfile.cpp" or
# directories like "/usr/src/myproject". Separate the files or directories
# with spaces.
INPUT += @top_srcdir@/dune/
# see e.g. dune-grid for the examples of mainpage and modules
# INPUT += @srcdir@/mainpage \
# @srcdir@/modules
# The EXCLUDE tag can be used to specify files and/or directories that should
# excluded from the INPUT source files. This way you can easily exclude a
# subdirectory from a directory tree whose root is specified with the INPUT tag.
# EXCLUDE += @top_srcdir@/dune/$NAME/test
# The EXAMPLE_PATH tag can be used to specify one or more files or
# directories that contain example code fragments that are included (see
# the \include command).
# EXAMPLE_PATH += @top_srcdir@/src
# The IMAGE_PATH tag can be used to specify one or more files or
# directories that contain image that are included in the documentation (see
# the \image command).
# IMAGE_PATH += @top_srcdir@/dune/$NAME/pics
CC_DELIM
################# doc/doxygen/Makefile.am #####################
echo "- $PROJECT/doc/doxygen/Makefile.am"
cat> "$PROJECT/doc/doxygen/Makefile.am" << CC_DELIM
BASEDIR=../..
CURDIR=doc/doxygen
include \$(top_srcdir)/am/doxygen
include \$(top_srcdir)/am/global-rules
CC_DELIM
################# doc/doxygen/CMakeLists.txt #####################
echo "- $PROJECT/doc/doxygen/CMakeLists.txt"
cat> "$PROJECT/doc/doxygen/CMakeLists.txt" << CC_DELIM
# shortcut for creating the Doxyfile.in and Doxyfile
add_doxygen_target()
CC_DELIM
############### The cmake subdirectory ##################
#########################################################
################# cmake/Makefile.am #####################
echo "- $PROJECT/cmake/Makefile.am"
cat> "$PROJECT/cmake/Makefile.am" <<EOF
SUBDIRS = modules
include \$(top_srcdir)/am/global-rules
EOF
############### The cmake subdirectory ##################
#########################################################
mkdir "$PROJECT/cmake/modules"
################# cmake/modules/Makefile.am #####################
macroname=""
for i in $(echo $PROJECT| sed 's/-/ /g'); do
firstchar=$(echo $i | sed 's/\(.\).*/\1/')
macroname=$macroname$(echo $firstchar | tr '[a-z]' '[A-Z]')$(echo $i | sed 's/.\(.*\)/\1/')
done
macroname="$macroname""Macros.cmake"
echo "- $PROJECT/cmake/modules/Makefile.am"
cat> "$PROJECT/cmake/modules/Makefile.am" <<EOF
MODULES = $macroname
modulesdir = \$(datadir)/dune/cmake/modules
dist_modules_DATA = \${MODULES}
include \$(top_srcdir)/am/global-rules
EXTRA_DIST = CMakeLists.txt
################# cmake/modules/Makefile.am #####################
echo "- $PROJECT/cmake/modules/CMakeLists.txt"
cat> "$PROJECT/cmake/modules/CMakeLists.txt" <<EOF
set(modules "$macroname")
install(FILES \${modules} DESTINATION \${DUNE_INSTALL_MODULEDIR})
EOF
################# cmake/modules/$macroname #####################
echo "- $PROJECT/cmake/modules/$macroname"
cat> "$PROJECT/cmake/modules/$macroname" <<EOF
# File for module specific CMake tests.
EOF
################# stamp-regenerate-config-h #####################
echo "- $PROJECT/stamp-regenerate-config-h"
touch $PROJECT/stamp-regenerate-config-h
echo
echo "done."
echo "------------------------------------------"
echo "For further details read the Dune Buildsystem-Howto:"
echo "http://www.dune-project.org/doc/buildsystem/buildsystem.pdf"